<!DOCTYPE html>
<html lang="">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width,initial-scale=1.0">
    <title>title</title>

    <script src="https://cdn.jsdelivr.net/npm/vue@2.7.8/dist/vue.js"></script>
  </head>
  <body>
     Content
     <div id="app">
      {{ message }}
      <input v-model="name" />
      <button @click="greet">Привет</button>
     </div>
  </body>
  <script>
    var app = new Vue({
      el: '#app',
      data: {
        message: 'Привет!',
        name: ''
      },
      methods: {
        greet() {
          this.message = `Привет, ${this.name}!`
        }
       }
    });
  </script>
</html>

Шаблон -> virtual DOM -> DOM
message -> vue следит -> подставляет в virtual DOM -> DOM